import React from "react";
import com from "./icon/com.png";
import ItemBase from "./ItemBase";
import Icon from "./icon/Icon";
import styled from "styled-components";

const Name = styled.div`
  font-size: 16px;
  font-family: MicrosoftYaHei;
  color: rgba(51, 51, 51, 1);
  margin-bottom:10px;
`;

const Intro = styled.div`
  font-size: 14px;
  font-family: MicrosoftYaHei;
  color: rgba(51, 51, 51, 1);
  white-space: pre;
  line-height:20px;
  overflow-wrap: anywhere;
`;

export default ({ company, intro }) => {
  const icon = <Icon src={com} width="28px" height="21px" />;
  return (
    <ItemBase icon={icon} title="公司介绍">
      <Name>{company}</Name>
      <Intro>{intro}</Intro>
    </ItemBase>
  );
};
